#include <SD.h>
#include <SPI.h>
#include <TMRpcm.h>

#define CS 10
#define BUZZ 9

#define C 8
#define D 7
#define E 6
#define F 5
#define G 4
#define A 3
#define B 2

#define PREV A0
#define NEXT A1
#define LOOP A2

#define C_Frequence 262
#define D_Frequence 294
#define E_Frequence 330
#define F_Frequence 349
#define G_Frequence 392
#define A_Frequence 440
#define B_Frequence 493

TMRpcm tmrpcm;

int iterator = 1;

void setup()
{
  pinMode(C, INPUT_PULLUP);
  pinMode(D, INPUT_PULLUP);
  pinMode(E, INPUT_PULLUP);
  pinMode(F, INPUT_PULLUP);
  pinMode(G, INPUT_PULLUP);
  pinMode(A, INPUT_PULLUP);
  pinMode(PREV, INPUT_PULLUP);
  pinMode(NEXT, INPUT_PULLUP);
  pinMode(LOOP, INPUT_PULLUP);

  Serial.begin(9600);
  tmrpcm.speakerPin = BUZZ;
  if (!SD.begin(CS)) {
    Serial.println("SD fails!");
    return;
  }
  tmrpcm.setVolume(5);
}

void play(){
  if (iterator == 1) {
    tmrpcm.stopPlayback();
    tmrpcm.play("piesa1.wav");
  }
  else if (iterator == 2) {
    tmrpcm.stopPlayback();
    tmrpcm.play("piesa2.wav");
  }
  else if (iterator == 3) {
    tmrpcm.stopPlayback();
    tmrpcm.play("piesa3.wav");
  }
  else if (iterator == 4) {
    tmrpcm.stopPlayback();
    tmrpcm.play("piesa4.wav");
  }
  else if (iterator == 5) {
    tmrpcm.stopPlayback();
    tmrpcm.play("piesa5.wav");
  }
}

void loop()
{
  while(digitalRead(C) == LOW)
  {
    tone(BUZZ, C_Frequence);
  }

  while(digitalRead(D) == LOW)
  {
    tone(BUZZ, D_Frequence);
  }

  while(digitalRead(E) == LOW)
  {
    tone(BUZZ, E_Frequence);
  }

  while(digitalRead(F) == LOW)
  {
    tone(BUZZ, F_Frequence);
  }

  while(digitalRead(G) == LOW)
  {
    tone(BUZZ, G_Frequence);
  }

  while(digitalRead(A) == LOW)
  {
    tone(BUZZ, A_Frequence);
  }
  
  while(digitalRead(B) == LOW)
  {
    tone(BUZZ, B_Frequence);
  }

  noTone(BUZZ);

  while (digitalRead(PREV) == LOW || digitalRead(NEXT) == LOW || digitalRead(LOOP) == LOW) {
    if (digitalRead(PREV) == 0) {
      if (iterator > 1) {
        iterator = iterator - 1;
        delay(200);
        play();
      }
    }
    if (digitalRead(NEXT) == LOW) {
      if (iterator < 5) {
        iterator = iterator + 1;
        delay(200);
        play();
      }
    }
    if (digitalRead(LOOP) == LOW) {
      tmrpcm.pause();
      delay(200);
    }
  }
}
